//segment is primary.c
//last revision on 07Nov23

// catalina primary.c -lc -lm -lserial4 -C NO_HMI -C FLIP -C XEPROM -C SMALL -C CACHED_4K -y

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <math.h>
#include <time.h>
#include <propeller.h>
#include "secondary.inc"

#define     Yes                 1
#define     No                  0
#define     conport             0
#define     print_command       1
#define     ROUNDUP             128

void check_memory(void *secondary_memory)
{
 if(SECONDARY_CODE_ADDRESS == (int) secondary_memory) return;
 for(;;)
  {
   s4_str(conport,"Error - Change secondary Memory To 0x");
   s4_hex(conport,secondary_memory,4);
   s4_str(conport,"\r\n");
   while(s4_rxcheck(conport) < 0);
  }
}

struct shared
{
    char request;
    char *format;
    char *outstr;    
 va_list ptr;
};

static struct shared  primary;

void priprint(void)
{
 vsprintf(primary.outstr,primary.format,primary.ptr);
 va_end(primary.ptr); 
 primary.request=0;
}

void main(void)
{
 char SECONDARY_RESERVED_SPACE[ROUNDUP * ((SECONDARY_RUNTIME_SIZE + ROUNDUP -1)/ROUNDUP)]; 
 check_memory(SECONDARY_RESERVED_SPACE);
 start_SECONDARY(&primary,ANY_COG);
 for(;;)
  {
   if(primary.request == print_command) priprint();
  }
}
